From dd3ae9c0e978b8011193401b7b0a4262952b462a Mon Sep 17 00:00:00 2001
From: "Endi S. Dewata" <edewata@redhat.com>
Date: Thu, 16 May 2013 13:06:14 -0500
Subject: [PATCH] Added Tomcat-based TPS instance.

The build and deployment tools have been modified to support creating
a basic Tomcat instance to run TPS. New configuration and template
files for TPS have been copied from another Tomcat subsystem. The TPS
functionality itself will be added in future patches.

Ticket #526
---
 .classpath                                         |   1 +
 CMakeLists.txt                                     |   1 +
 base/common/shared/webapps/ROOT/index.jsp          |  31 +
 .../src/com/netscape/certsrv/logging/ILogger.java  |   1 +
 base/server/etc/default.cfg                        |  22 +-
 base/server/scripts/operations                     |  21 +
 base/server/src/engine/pkiconfig.py                |  10 +-
 base/server/src/engine/pkihelper.py                |   6 +-
 base/server/src/engine/pkiparser.py                |  12 +-
 base/server/src/pkidestroy                         |   4 +-
 base/server/src/pkispawn                           |   4 +-
 base/server/src/scriptlets/configuration.py        |   9 +-
 base/server/src/scriptlets/webapp_deployment.py    |   3 +
 base/tps/CMakeLists.txt                            |  17 +
 base/tps/java/CMakeLists.txt                       | 129 +++
 .../org/dogtagpki/tps/server/TPSApplication.java   |  79 ++
 .../org/dogtagpki/tps/server/TPSAuthority.java     | 102 +++
 base/tps/java/pki-tps.mf                           |   3 +
 base/tps/shared/conf/CS.cfg.in                     |  95 ++
 base/tps/shared/conf/acl.ldif                      |  22 +
 base/tps/shared/conf/catalina.policy               | 182 ++++
 base/tps/shared/conf/catalina.properties           |  87 ++
 base/tps/shared/conf/context.xml                   |  40 +
 base/tps/shared/conf/database.ldif                 |   9 +
 base/tps/shared/conf/db.ldif                       |  66 ++
 base/tps/shared/conf/etc/init.d/pki-tpsd           |  86 ++
 base/tps/shared/conf/index.ldif                    | 203 +++++
 base/tps/shared/conf/jk2.manifest                  |   2 +
 base/tps/shared/conf/jk2.properties                |  31 +
 base/tps/shared/conf/jkconf.ant.xml                |  55 ++
 base/tps/shared/conf/jkconfig.manifest             |   2 +
 base/tps/shared/conf/logging.properties            |  70 ++
 base/tps/shared/conf/manager.ldif                  |  46 +
 base/tps/shared/conf/schema.ldif                   | 489 ++++++++++
 base/tps/shared/conf/server-minimal.xml            |  29 +
 base/tps/shared/conf/server.xml                    | 258 ++++++
 base/tps/shared/conf/shm.manifest                  |   2 +
 base/tps/shared/conf/tomcat-jk2.manifest           |   7 +
 base/tps/shared/conf/tomcat-users.xml              |  45 +
 base/tps/shared/conf/tomcat6.conf                  |  58 ++
 base/tps/shared/conf/uriworkermap.properties       |  18 +
 base/tps/shared/conf/web.xml                       | 993 +++++++++++++++++++++
 base/tps/shared/conf/workers.properties            | 209 +++++
 base/tps/shared/conf/workers.properties.minimal    |  22 +
 base/tps/shared/conf/workers2.properties           | 136 +++
 base/tps/shared/conf/workers2.properties.minimal   |  60 ++
 base/tps/shared/etc/init.d/pki-tpsd                |  86 ++
 base/tps/shared/lib/systemd/system/pki-tpsd.target |   6 +
 .../shared/lib/systemd/system/pki-tpsd@.service    |  12 +
 base/tps/shared/webapps/tps/404.html               | 145 +++
 base/tps/shared/webapps/tps/500.html               | 138 +++
 .../shared/webapps/tps/GenUnexpectedError.template |  67 ++
 base/tps/shared/webapps/tps/META-INF/context.xml   |  35 +
 .../tps/shared/webapps/tps/WEB-INF/auth.properties |  10 +
 .../shared/webapps/tps/WEB-INF/velocity.properties |  13 +
 base/tps/shared/webapps/tps/WEB-INF/web.xml        | 178 ++++
 base/tps/shared/webapps/tps/index.html             |  23 +
 base/tps/shared/webapps/tps/services.template      | 106 +++
 specs/pki-tps.spec                                 |  14 +-
 59 files changed, 4580 insertions(+), 30 deletions(-)
 create mode 100644 base/tps/java/CMakeLists.txt
 create mode 100644 base/tps/java/org/dogtagpki/tps/server/TPSApplication.java
 create mode 100644 base/tps/java/org/dogtagpki/tps/server/TPSAuthority.java
 create mode 100644 base/tps/java/pki-tps.mf
 create mode 100644 base/tps/shared/conf/acl.ldif
 create mode 100644 base/tps/shared/conf/catalina.policy
 create mode 100644 base/tps/shared/conf/catalina.properties
 create mode 100644 base/tps/shared/conf/context.xml
 create mode 100644 base/tps/shared/conf/database.ldif
 create mode 100644 base/tps/shared/conf/db.ldif
 create mode 100755 base/tps/shared/conf/etc/init.d/pki-tpsd
 create mode 100644 base/tps/shared/conf/index.ldif
 create mode 100644 base/tps/shared/conf/jk2.manifest
 create mode 100644 base/tps/shared/conf/jk2.properties
 create mode 100644 base/tps/shared/conf/jkconf.ant.xml
 create mode 100644 base/tps/shared/conf/jkconfig.manifest
 create mode 100644 base/tps/shared/conf/logging.properties
 create mode 100644 base/tps/shared/conf/manager.ldif
 create mode 100644 base/tps/shared/conf/schema.ldif
 create mode 100644 base/tps/shared/conf/server-minimal.xml
 create mode 100644 base/tps/shared/conf/server.xml
 create mode 100644 base/tps/shared/conf/shm.manifest
 create mode 100644 base/tps/shared/conf/tomcat-jk2.manifest
 create mode 100644 base/tps/shared/conf/tomcat-users.xml
 create mode 100644 base/tps/shared/conf/tomcat6.conf
 create mode 100644 base/tps/shared/conf/uriworkermap.properties
 create mode 100644 base/tps/shared/conf/web.xml
 create mode 100644 base/tps/shared/conf/workers.properties
 create mode 100644 base/tps/shared/conf/workers.properties.minimal
 create mode 100644 base/tps/shared/conf/workers2.properties
 create mode 100644 base/tps/shared/conf/workers2.properties.minimal
 create mode 100755 base/tps/shared/etc/init.d/pki-tpsd
 create mode 100644 base/tps/shared/lib/systemd/system/pki-tpsd.target
 create mode 100644 base/tps/shared/lib/systemd/system/pki-tpsd@.service
 create mode 100755 base/tps/shared/webapps/tps/404.html
 create mode 100755 base/tps/shared/webapps/tps/500.html
 create mode 100644 base/tps/shared/webapps/tps/GenUnexpectedError.template
 create mode 100644 base/tps/shared/webapps/tps/META-INF/context.xml
 create mode 100644 base/tps/shared/webapps/tps/WEB-INF/auth.properties
 create mode 100644 base/tps/shared/webapps/tps/WEB-INF/velocity.properties
 create mode 100644 base/tps/shared/webapps/tps/WEB-INF/web.xml
 create mode 100644 base/tps/shared/webapps/tps/index.html
 create mode 100644 base/tps/shared/webapps/tps/services.template

diff --git a/.classpath b/.classpath
index 244624c1350dadf17c72bcf7c36db99e7c4e6b73..0cc81a118ff43532d8b8dcbdd43b9b6572017048 100644
--- a/.classpath
+++ b/.classpath
@@ -16,6 +16,7 @@
 	<classpathentry kind="src" path="base/kra/functional/src"/>
 	<classpathentry kind="src" path="base/common/functional/src"/>
 	<classpathentry kind="src" path="base/ca/functional/src"/>
+	<classpathentry kind="src" path="base/tps/java"/>
 	<classpathentry kind="con" path="org.eclipse.jdt.launching.JRE_CONTAINER"/>
 	<classpathentry kind="lib" path="/usr/share/java/apache-commons-cli.jar"/>
 	<classpathentry kind="lib" path="/usr/share/java/apache-commons-logging.jar"/>
diff --git a/CMakeLists.txt b/CMakeLists.txt
index 304884e83b2c25e313b994f226ca908a5399b853..7e679d06eefd2edcf795022d5a7e29ab06d3e59e 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -82,6 +82,7 @@ endif ()
 
 # ONLY required for Java-based PKI components
 if (APPLICATION_FLAVOR_PKI_CORE      OR
+    APPLICATION_FLAVOR_PKI_TPS       OR
     APPLICATION_FLAVOR_PKI_CONSOLE   OR
     APPLICATION_FLAVOR_DOGTAG_PKI_THEME OR
     APPLICATION_FLAVOR_PKI_MIGRATE)
diff --git a/base/common/shared/webapps/ROOT/index.jsp b/base/common/shared/webapps/ROOT/index.jsp
index ae2faa9d70da0ba117fffc83c41455d26f0d302b..f5ef47df2e31a5a14f6c1b72edf1e3ec4a412100 100644
--- a/base/common/shared/webapps/ROOT/index.jsp
+++ b/base/common/shared/webapps/ROOT/index.jsp
@@ -198,6 +198,37 @@
 
 <%
     }
+
+    ServletContext tpsContext = getServletContext().getContext("/tps");
+    String tpsName = tpsContext.getServletContextName();
+    String tpsPath = tpsContext.getContextPath();
+    if (!"".equals(tpsPath) && request.isSecure()) {
+%>
+<p>
+<font size="+1" face="PrimaSans BT, Verdana, Arial, Helvetica, sans-serif">
+<%= tpsName %>
+</font>
+</p>
+
+<table border="0" cellspacing="0" cellpadding="0">
+<tr valign="TOP">
+    <td>
+        <li><font size=4 face="PrimaSans BT, Verdana, sans-serif">
+        <a href="/tps/agent/tps">Agent Services</a></font>
+    </td>
+</tr>
+<tr valign="TOP">
+    <td>
+        <li><font size=4 face="PrimaSans BT, Verdana, sans-serif">
+        <a href="/tps/services">Admin Services</a></font>
+    </td>
+</tr>
+</table>
+
+<br>
+
+<%
+    }
 %>
 
 </center>
diff --git a/base/common/src/com/netscape/certsrv/logging/ILogger.java b/base/common/src/com/netscape/certsrv/logging/ILogger.java
index 10ec35337707d91304778b549ebc94bcf4f99f36..c036a538b5853a79ffb5e0dbfdcf5701af7f3c09 100644
--- a/base/common/src/com/netscape/certsrv/logging/ILogger.java
+++ b/base/common/src/com/netscape/certsrv/logging/ILogger.java
@@ -134,6 +134,7 @@ public interface ILogger {
      */
 
     public static final int S_TKS = 16;
+    public static final int S_TPS = 17;
 
     /**
      * log source: identify the log entry is from other subsystem
diff --git a/base/server/etc/default.cfg b/base/server/etc/default.cfg
index b2af83857378c21c83bd407d335cd112c73915ce..b67b6670ecb7703fee659a9e21b108cdefffff41 100644
--- a/base/server/etc/default.cfg
+++ b/base/server/etc/default.cfg
@@ -189,13 +189,13 @@ pki_subsystem_registry_path=%(pki_instance_registry_path)s/%(pki_subsystem_type)
 ##  Tomcat Configuration:                                                    ##
 ##                                                                           ##
 ##  Values in this section are common to PKI subsystems that run             ##
-##  as an instance of 'Tomcat' (CA, KRA, OCSP, and TKS subsystems            ##
+##  as an instance of 'Tomcat' (CA, KRA, OCSP, TKS, and TPS subsystems       ##
 ##  including 'Clones', 'Subordinate CAs', and 'External CAs'), and contain  ##
 ##  required information which MAY be overridden by users as necessary.      ##
 ##                                                                           ##
 ##  PKI CLONES:  To specify a 'CA Clone', a 'KRA Clone', an 'OCSP Clone',    ##
-##               or a 'TKS Clone', change the value of 'pki_clone'           ##
-##               from 'False' to 'True'.                                     ##
+##               a 'TKS Clone', or a 'TPS Clone', change the value of        ##
+##               'pki_clone' from 'False' to 'True'.                         ##
 ##                                                                           ##
 ##    REMINDER:  PKI CA Clones, Subordinate CAs, and External CAs            ##
 ##               are MUTUALLY EXCLUSIVE entities!!!                          ##
@@ -334,6 +334,8 @@ pki_ocsp_jar=/usr/share/java/pki/pki-ocsp.jar
 pki_ocsp_jar_link=%(pki_tomcat_webapps_subsystem_webinf_lib_path)s/pki-ocsp.jar
 pki_tks_jar=/usr/share/java/pki/pki-tks.jar
 pki_tks_jar_link=%(pki_tomcat_webapps_subsystem_webinf_lib_path)s/pki-tks.jar
+pki_tps_jar=/usr/share/java/pki/pki-tps.jar
+pki_tps_jar_link=%(pki_tomcat_webapps_subsystem_webinf_lib_path)s/pki-tps.jar
 
 
 
@@ -525,6 +527,20 @@ pki_subsystem_subject_dn=cn=TKS Subsystem Certificate,o=%(pki_security_domain_na
 ##  required information which MAY be overridden by users as necessary.      ##
 ###############################################################################
 [TPS]
+pki_import_admin_cert=True
+pki_admin_email=%(pki_admin_name)s@%(pki_dns_domainname)s
+pki_admin_name=%(pki_admin_uid)s
+pki_admin_nickname=PKI Administrator for %(pki_dns_domainname)s
+pki_admin_subject_dn=cn=PKI Administrator,e=%(pki_admin_email)s,o=%(pki_security_domain_name)s
+pki_admin_uid=tpsadmin
+pki_audit_signing_nickname=auditSigningCert cert-%(pki_instance_name)s TPS
+pki_audit_signing_subject_dn=cn=TPS Audit Signing Certificate,o=%(pki_security_domain_name)s
+pki_ds_base_dn=o=%(pki_instance_name)s-TPS
+pki_ds_database=%(pki_instance_name)s-TPS
+pki_ds_hostname=%(pki_hostname)s
+pki_subsystem_name=TPS %(pki_hostname)s %(pki_https_port)s
+pki_subsystem_nickname=subsystemCert cert-%(pki_instance_name)s TPS
+pki_subsystem_subject_dn=cn=TPS Subsystem Certificate,o=%(pki_security_domain_name)s
 
 # Paths
 # These are used in the processing of pkispawn and are not supposed
diff --git a/base/server/scripts/operations b/base/server/scripts/operations
index 2a07802f8a412665b4c0ebb3902af9bde30c936f..93d3bda9018c8c7f6af90d9a81928260de0b2f0e 100644
--- a/base/server/scripts/operations
+++ b/base/server/scripts/operations
@@ -1080,11 +1080,13 @@ verify_symlinks()
     declare -A kra_symlinks
     declare -A ocsp_symlinks
     declare -A tks_symlinks
+    declare -A tps_symlinks
     declare -A common_jar_symlinks
     declare -A ca_jar_symlinks
     declare -A kra_jar_symlinks
     declare -A ocsp_jar_symlinks
     declare -A tks_jar_symlinks
+    declare -A tps_jar_symlinks
     declare -A systemd_symlinks
 
     # Dogtag 10 Conditional Variables
@@ -1104,6 +1106,7 @@ verify_symlinks()
     pki_kra_jar_dir="${PKI_INSTANCE_PATH}/webapps/kra/WEB-INF/lib"
     pki_ocsp_jar_dir="${PKI_INSTANCE_PATH}/webapps/ocsp/WEB-INF/lib"
     pki_tks_jar_dir="${PKI_INSTANCE_PATH}/webapps/tks/WEB-INF/lib"
+    pki_tps_jar_dir="${PKI_INSTANCE_PATH}/webapps/tps/WEB-INF/lib"
 
     # '${PKI_INSTANCE_PATH}' symlinks
     base_symlinks=(
@@ -1187,6 +1190,24 @@ verify_symlinks()
         [pki-nsutil.jar]=${java_dir}/pki/pki-nsutil.jar
         [pki-tks.jar]=${java_dir}/pki/pki-tks.jar)
 
+    # '${PKI_INSTANCE_PATH}/tps' symlinks
+    tps_symlinks=(
+        [alias]=${PKI_INSTANCE_PATH}/alias
+        [conf]=/etc/pki/${PKI_INSTANCE_NAME}/tps
+        [logs]=/var/log/pki/${PKI_INSTANCE_NAME}/tps
+        [registry]=${pki_registry_dir}
+        [webapps]=${PKI_INSTANCE_PATH}/webapps)
+
+    # '${pki_tps_jar_dir}' symlinks
+    tps_jar_symlinks=(
+        [pki-certsrv.jar]=${java_dir}/pki/pki-certsrv.jar
+        [pki-cms.jar]=${java_dir}/pki/pki-cms.jar
+        [pki-cmsbundle.jar]=${java_dir}/pki/pki-cmsbundle.jar
+        [pki-cmscore.jar]=${java_dir}/pki/pki-cmscore.jar
+        [pki-cmsutil.jar]=${java_dir}/pki/pki-cmsutil.jar
+        [pki-nsutil.jar]=${java_dir}/pki/pki-nsutil.jar
+        [pki-tps.jar]=${java_dir}/pki/pki-tps.jar)
+
     # '${pki_common_jar_dir}' symlinks
     common_jar_symlinks=(
         [apache-commons-codec.jar]=${java_dir}/commons-codec.jar
diff --git a/base/server/src/engine/pkiconfig.py b/base/server/src/engine/pkiconfig.py
index 3a3a7df18f376a13ea61477618876aa5eebf4d42..6a86de0874bcf77e36a7b34a92d8b89da4e50938 100644
--- a/base/server/src/engine/pkiconfig.py
+++ b/base/server/src/engine/pkiconfig.py
@@ -39,15 +39,15 @@ PKI_DEPLOYMENT_DEFAULT_USER = "pkiuser"
 
 PKI_SUBSYSTEMS = ["CA","KRA","OCSP","RA","TKS","TPS"]
 PKI_SIGNED_AUDIT_SUBSYSTEMS = ["CA","KRA","OCSP","TKS","TPS"]
-PKI_APACHE_SUBSYSTEMS = ["RA","TPS"]
-PKI_TOMCAT_SUBSYSTEMS = ["CA","KRA","OCSP","TKS"]
+PKI_APACHE_SUBSYSTEMS = ["RA"]
+PKI_TOMCAT_SUBSYSTEMS = ["CA","KRA","OCSP","TKS", "TPS"]
 PKI_BASE_RESERVED_NAMES = ["alias", "bin", "ca", "common", "conf", "kra",
-                           "lib", "logs", "ocsp", "temp", "tks", "webapps",
+                           "lib", "logs", "ocsp", "temp", "tks", "tps", "webapps",
                            "work"]
 PKI_CONFIGURATION_RESERVED_NAMES = ["CA", "java", "nssdb", "rpm-gpg",
                                     "rsyslog", "tls"]
-PKI_APACHE_REGISTRY_RESERVED_NAMES = ["ra", "tps"]
-PKI_TOMCAT_REGISTRY_RESERVED_NAMES = ["ca", "kra", "ocsp", "tks"]
+PKI_APACHE_REGISTRY_RESERVED_NAMES = ["ra"]
+PKI_TOMCAT_REGISTRY_RESERVED_NAMES = ["ca", "kra", "ocsp", "tks", "tps"]
 
 PKI_INDENTATION_LEVEL_0 = {'indent' : ''}
 PKI_INDENTATION_LEVEL_1 = {'indent' : '... '}
diff --git a/base/server/src/engine/pkihelper.py b/base/server/src/engine/pkihelper.py
index df36583079cea16a0d199de3e0007bc7a1a12e12..c0a659fd4de55bd0339ed2a34503d9b563ef65c7 100644
--- a/base/server/src/engine/pkihelper.py
+++ b/base/server/src/engine/pkihelper.py
@@ -520,7 +520,7 @@ class configuration_file:
                     raise Exception(log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 % ("pki_clone_pkcs12_password",
                                                                                          master['pki_user_deployment_cfg']))
             # Verify existence of Security Domain Password File
-            # (ONLY for Clones, KRA, OCSP, TKS, or Subordinate CA)
+            # (ONLY for Clones, KRA, OCSP, TKS, TPS, or Subordinate CA)
             if config.str2bool(master['pki_clone']) or\
                not master['pki_subsystem'] == "CA" or\
                config.str2bool(master['pki_subordinate']):
@@ -3171,7 +3171,7 @@ class config_client:
            config.str2bool(master['pki_clone']) or\
            config.str2bool(master['pki_subordinate']):
             # PKI KRA, PKI OCSP, PKI RA, PKI TKS, PKI TPS,
-            # CA Clone, KRA Clone, OCSP Clone, TKS Clone, or
+            # CA Clone, KRA Clone, OCSP Clone, TKS Clone, TPS Clone, or
             # Subordinate CA
             self.set_existing_security_domain(data)
         else:
@@ -3401,7 +3401,7 @@ class config_client:
            config.str2bool(master['pki_subordinate']) or\
            config.str2bool(master['pki_external']):
             # PKI KRA, PKI OCSP, PKI RA, PKI TKS, PKI TPS,
-            # CA Clone, KRA Clone, OCSP Clone, TKS Clone,
+            # CA Clone, KRA Clone, OCSP Clone, TKS Clone, TPS Clone,
             # Subordinate CA, or External CA
             data.issuingCA = master['pki_issuing_ca']
             if master['pki_subsystem'] == "CA"  and\
diff --git a/base/server/src/engine/pkiparser.py b/base/server/src/engine/pkiparser.py
index 6a94e382719a1e35da764336542ac10e470c2f3a..c8a592d538c8d42e2f6bb30dd9df1fc446604f0b 100644
--- a/base/server/src/engine/pkiparser.py
+++ b/base/server/src/engine/pkiparser.py
@@ -881,9 +881,9 @@ class PKIConfigParser:
             # 'Subsystem Name'  Configuration name/value pairs
             # 'Token'           Configuration name/value pairs
             #
-            #     Apache - [RA], [TPS]
-            #     Tomcat - [CA], [KRA], [OCSP], [TKS]
-            #            - [CA Clone], [KRA Clone], [OCSP Clone], [TKS Clone]
+            #     Apache - [RA]
+            #     Tomcat - [CA], [KRA], [OCSP], [TKS], [TPS]
+            #            - [CA Clone], [KRA Clone], [OCSP Clone], [TKS Clone], [TPS Clone]
             #            - [External CA]
             #            - [Subordinate CA]
             #
@@ -933,7 +933,7 @@ class PKIConfigParser:
                config.str2bool(config.pki_master_dict['pki_clone']) or\
                config.str2bool(config.pki_master_dict['pki_subordinate']):
                 # PKI KRA, PKI OCSP, PKI RA, PKI TKS, PKI TPS,
-                # CA Clone, KRA Clone, OCSP Clone, TKS Clone, or
+                # CA Clone, KRA Clone, OCSP Clone, TKS Clone, TPS Clone, or
                 # Subordinate CA
                 config.pki_master_dict['pki_security_domain_type'] = "existing"
                 config.pki_master_dict['pki_security_domain_uri'] =\
@@ -965,8 +965,8 @@ class PKIConfigParser:
 
             # 'Backup' Configuration name/value pairs
             #
-            #     Apache - [RA], [TPS]
-            #     Tomcat - [CA], [KRA], [OCSP], [TKS]
+            #     Apache - [RA]
+            #     Tomcat - [CA], [KRA], [OCSP], [TKS], [TPS]
             #            - [External CA]
             #            - [Subordinate CA]
             #
diff --git a/base/server/src/pkidestroy b/base/server/src/pkidestroy
index 4e23445f16056b7992bcfd87125822c975490153..1e3f7f5788840db73c612d194931d17c45addaf8 100755
--- a/base/server/src/pkidestroy
+++ b/base/server/src/pkidestroy
@@ -129,8 +129,8 @@ def main(argv):
         # -s <subsystem>
         if args.pki_subsystem is None:
             interactive = True
-            config.pki_subsystem = parser.read_text('Subsystem (CA/KRA/OCSP/TKS)',
-                options=['CA', 'KRA', 'OCSP', 'TKS'],
+            config.pki_subsystem = parser.read_text('Subsystem (CA/KRA/OCSP/TKS/TPS)',
+                options=['CA', 'KRA', 'OCSP', 'TKS', 'TPS'],
                 default='CA', caseSensitive=False).upper()
         else:
             config.pki_subsystem = str(args.pki_subsystem).strip('[\']')
diff --git a/base/server/src/pkispawn b/base/server/src/pkispawn
index f78e50867b44a36a4a654056ab52ffddaa3575c2..8a89c76f3e791e434d3d0b1204b67fe6f0fb2363 100755
--- a/base/server/src/pkispawn
+++ b/base/server/src/pkispawn
@@ -129,8 +129,8 @@ def main(argv):
             interactive = True
             parser.indent = 0
 
-            config.pki_subsystem = parser.read_text('Subsystem (CA/KRA/OCSP/TKS)',
-                options=['CA', 'KRA', 'OCSP', 'TKS'],
+            config.pki_subsystem = parser.read_text('Subsystem (CA/KRA/OCSP/TKS/TPS)',
+                options=['CA', 'KRA', 'OCSP', 'TKS', 'TPS'],
                 default='CA', caseSensitive=False).upper()
             print
         else:
diff --git a/base/server/src/scriptlets/configuration.py b/base/server/src/scriptlets/configuration.py
index 43f8c16cd1a67e2feb8386050ff6fcfa01d52621..c13e7eba2a63fecc7b42bc266f7f7e4233f48916 100644
--- a/base/server/src/scriptlets/configuration.py
+++ b/base/server/src/scriptlets/configuration.py
@@ -113,14 +113,9 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
                 config.pki_log.info(log.PKI_CONFIG_NOT_YET_IMPLEMENTED_1,
                     master['pki_subsystem'],
                     extra=config.PKI_INDENTATION_LEVEL_2)
-                return rv
-        elif master['pki_subsystem'] == "TPS":
-                config.pki_log.info(log.PKI_CONFIG_NOT_YET_IMPLEMENTED_1,
-                    master['pki_subsystem'],
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                return rv
+                return self.rv
         elif master['pki_instance_type'] == "Tomcat":
-            # CA, KRA, OCSP, or TKS
+            # CA, KRA, OCSP, TKS, or TPS
             data = config_client.construct_pki_configuration_data()
         
         # Configure the substem
diff --git a/base/server/src/scriptlets/webapp_deployment.py b/base/server/src/scriptlets/webapp_deployment.py
index 4fdcc8614baf2bc816fc865ca3bf420ba6ef5091..aa52009fb1a0e6deb3e33223bd2a0a672f043fad 100644
--- a/base/server/src/scriptlets/webapp_deployment.py
+++ b/base/server/src/scriptlets/webapp_deployment.py
@@ -152,6 +152,9 @@ class PkiScriptlet(pkiscriptlet.AbstractBasePkiScriptlet):
             elif master['pki_subsystem'] == "TKS":
                 util.symlink.create(master['pki_tks_jar'],
                                     master['pki_tks_jar_link'])
+            elif master['pki_subsystem'] == "TPS":
+                util.symlink.create(master['pki_tps_jar'],
+                                    master['pki_tps_jar_link'])
             # set ownerships, permissions, and acls
             util.directory.set_mode(master['pki_tomcat_webapps_subsystem_path'])
         return self.rv
diff --git a/base/tps/CMakeLists.txt b/base/tps/CMakeLists.txt
index 7f8c38c57a046c077185572345a5fe282753730b..aa6ac8cb188a9c6c7f9d1d385feaf734c0f3a100 100644
--- a/base/tps/CMakeLists.txt
+++ b/base/tps/CMakeLists.txt
@@ -36,6 +36,7 @@ SET(CMAKE_INSTALL_RPATH "${LIB_INSTALL_DIR}/tps")
 # which point to directories outside the build tree to the install RPATH
 SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
 
+add_subdirectory(java)
 add_subdirectory(src)
 add_subdirectory(tools)
 
@@ -213,3 +214,19 @@ install(
     DESTINATION
         ${SYSTEMD_ETC_INSTALL_DIR}/pki-tpsd.target.wants
 )
+
+# install directories
+install(
+    DIRECTORY
+        shared/
+    DESTINATION
+        ${SHARE_INSTALL_PREFIX}/${APPLICATION_NAME}/${PROJECT_NAME}
+    PATTERN
+        "CMakeLists.txt" EXCLUDE
+    PATTERN
+        "etc/*" EXCLUDE
+    PATTERN
+        "conf/CS.cfg.in" EXCLUDE
+    PATTERN
+        "lib/*" EXCLUDE
+)
diff --git a/base/tps/java/CMakeLists.txt b/base/tps/java/CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..9cfad9f0cf9cfd6f34bd6f726cc1b2242eb9069c
--- /dev/null
+++ b/base/tps/java/CMakeLists.txt
@@ -0,0 +1,129 @@
+project(pki-tps_java NONE)
+
+find_file(LDAPJDK_JAR
+    NAMES
+        ldapjdk.jar
+    PATHS
+        /usr/share/java
+)
+
+find_file(JAXRS_API_JAR
+    NAMES
+        jaxrs-api.jar
+    PATHS
+        ${RESTEASY_LIB}
+)
+
+find_file(JSS_JAR
+    NAMES
+        jss4.jar
+    PATHS
+        ${JAVA_LIB_INSTALL_DIR}
+)
+
+find_file(COMMONS_CODEC_JAR
+    NAMES
+        commons-codec.jar
+    PATHS
+        /usr/share/java
+)
+
+find_file(JAXRS_API_JAR
+    NAMES
+        jaxrs-api.jar
+    PATHS
+        ${RESTEASY_LIB}
+)
+
+find_file(PKI_CERTSRV_JAR
+    NAMES
+        pki-certsrv.jar
+    PATHS
+        /usr/share/java/pki
+)
+
+find_file(PKI_CMS_JAR
+    NAMES
+        pki-cms.jar
+    PATHS
+        /usr/share/java/pki
+)
+
+find_file(PKI_CMSCORE_JAR
+    NAMES
+        pki-cmscore.jar
+    PATHS
+        /usr/share/java/pki
+)
+
+find_file(PKI_CMSUTIL_JAR
+    NAMES
+        pki-cmsutil.jar
+    PATHS
+        /usr/share/java/pki
+)
+
+find_file(PKI_NSUTIL_JAR
+    NAMES
+        pki-nsutil.jar
+    PATHS
+        /usr/share/java/pki
+)
+
+find_file(SERVLET_JAR
+    NAMES
+        servlet.jar
+    PATHS
+        ${JAVA_LIB_INSTALL_DIR}
+        /usr/share/java
+)
+
+find_file(SYMKEY_JAR
+    NAMES
+        symkey.jar
+    PATHS
+        ${JAVA_LIB_INSTALL_DIR}
+        /usr/share/java
+)
+
+# build pki-tps
+javac(pki-tps-classes
+    SOURCES
+        org/dogtagpki/tps/*.java
+    CLASSPATH
+        ${PKI_CERTSRV_JAR} ${PKI_CMS_JAR} ${PKI_CMSCORE_JAR}
+        ${PKI_CMSUTIL_JAR} ${PKI_NSUTIL_JAR}
+        ${LDAPJDK_JAR} ${JAXRS_API_JAR}
+        ${JSS_JAR} ${COMMONS_CODEC_JAR} ${SYMKEY_JAR} ${SERVLET_JAR}
+    OUTPUT_DIR
+        ${CMAKE_BINARY_DIR}/classes
+)
+
+configure_file(
+    ${CMAKE_CURRENT_SOURCE_DIR}/pki-tps.mf
+    ${CMAKE_CURRENT_BINARY_DIR}/pki-tps.mf
+)
+
+jar(pki-tps-jar
+    CREATE
+        ${CMAKE_BINARY_DIR}/dist/pki-tps.jar
+    OPTIONS
+        m
+    PARAMS
+        ${CMAKE_CURRENT_BINARY_DIR}/pki-tps.mf
+    INPUT_DIR
+        ${CMAKE_BINARY_DIR}/classes
+    FILES
+        org/dogtagpki/tps/*.class
+    DEPENDS
+        pki-tps-classes
+)
+
+install(
+    FILES
+        ${CMAKE_BINARY_DIR}/dist/pki-tps.jar
+    DESTINATION
+        ${JAVA_JAR_INSTALL_DIR}/pki
+)
+
+set(PKI_TPS_JAR ${CMAKE_BINARY_DIR}/dist/pki-tps.jar CACHE INTERNAL "pki-tps jar file")
diff --git a/base/tps/java/org/dogtagpki/tps/server/TPSApplication.java b/base/tps/java/org/dogtagpki/tps/server/TPSApplication.java
new file mode 100644
index 0000000000000000000000000000000000000000..4b05be934b2396d85818033372b7543996b0b6be
--- /dev/null
+++ b/base/tps/java/org/dogtagpki/tps/server/TPSApplication.java
@@ -0,0 +1,79 @@
+// --- BEGIN COPYRIGHT BLOCK ---
+// This program is free software; you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation; version 2 of the License.
+//
+// This program is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License along
+// with this program; if not, write to the Free Software Foundation, Inc.,
+// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+//
+// (C) 2013 Red Hat, Inc.
+// All rights reserved.
+// --- END COPYRIGHT BLOCK ---
+package org.dogtagpki.tps.server;
+
+import java.util.HashSet;
+import java.util.Set;
+
+import javax.ws.rs.core.Application;
+
+import com.netscape.certsrv.acls.ACLInterceptor;
+import com.netscape.certsrv.authentication.AuthMethodInterceptor;
+import com.netscape.certsrv.base.PKIException;
+import com.netscape.cms.servlet.account.AccountService;
+import com.netscape.cms.servlet.admin.GroupMemberService;
+import com.netscape.cms.servlet.admin.GroupService;
+import com.netscape.cms.servlet.admin.SystemCertService;
+import com.netscape.cms.servlet.admin.UserCertService;
+import com.netscape.cms.servlet.admin.UserMembershipService;
+import com.netscape.cms.servlet.admin.UserService;
+import com.netscape.cms.servlet.csadmin.SystemConfigService;
+
+/**
+ * @author Endi S. Dewata <edewata@redhat.com>
+ */
+public class TPSApplication extends Application {
+
+    private Set<Object> singletons = new HashSet<Object>();
+    private Set<Class<?>> classes = new HashSet<Class<?>>();
+
+    public TPSApplication() {
+
+        // account
+        classes.add(AccountService.class);
+
+        // installer
+        classes.add(SystemConfigService.class);
+
+        // user and group management
+        classes.add(GroupMemberService.class);
+        classes.add(GroupService.class);
+        classes.add(UserCertService.class);
+        classes.add(UserMembershipService.class);
+        classes.add(UserService.class);
+
+        // system certs
+        classes.add(SystemCertService.class);
+
+        // exception mapper
+        classes.add(PKIException.Mapper.class);
+
+        // interceptors
+        singletons.add(new AuthMethodInterceptor());
+        singletons.add(new ACLInterceptor());
+    }
+
+    public Set<Class<?>> getClasses() {
+        return classes;
+    }
+
+    public Set<Object> getSingletons() {
+        return singletons;
+    }
+
+}
